
"""
$Id: testPropertyAdapterRegistry.py,v 1.2 2003/05/21 00:04:00 philipp Exp $
"""

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.RevisionManager.interfaces.Properties import \
     IPropertyAdapter, IPropertyAdapterRegistry
from Products.RevisionManager.Properties import PropertyAdapterRegistry

ZopeTestCase.installProduct('RevisionManager')

class A:
    pass

class B(A):
    pass

class C(A):
    pass

class D(B, C):
    pass

class FakeAdapter:

    __implements__ = IPropertyAdapter

class PropertyAdapterRegistryTest(ZopeTestCase.ZopeTestCase):

    def afterSetUp(self):
        self.registry = PropertyAdapterRegistry()

    def afterClear(self):
        pass

    def test_verify_interface(self):
        """Verify interface implementation"""
        from Interface.Verify import verifyClass
        self.failUnless(verifyClass(IPropertyAdapterRegistry, PropertyAdapterRegistry))

    def testRegistry(self):
        """Test adapter registry"""
        registry = self.registry
        adapter = FakeAdapter()
        registry.registerForClass(A, adapter)
        d = D()
        ad = registry.getAdapter(d)
        self.assertEqual(adapter, ad)

if __name__ == '__main__':
    framework(descriptions=1, verbosity=2)
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(PropertyAdapterRegistryTest))
        return suite
